/ to compile for I/D space  as -o l.o d.s l.s
/ low core


	br4 = 200
	br5 = 240
	br6 = 300
	br7 = 340


/ execution starts here

. = 0^.
	br	1f
	0


/ trap vectors

	.globl	trap

	trap; br7+0.		/ bus error
	trap; br7+1.		/ illegal instruction
	trap; br7+2.		/ bpt-trace trap
	trap; br7+3.		/ iot trap
	trap; br7+4.		/ power fail
	trap; br7+5.		/ emulator trap
	trap; br7+6.		/ system entry


/ entry points and random data

.globl	start, dump, bounce

. = 40^.
1:	jmp	start
	jmp	dump

. = 50^.
bounce:	0			/ bouncing bits hack


/ interrupt vectors

. = 60^.
	dlin; br4+0.		/ CTY
	dlou; br4+0.

. = 100^.
	kwlp; br6		/ clocks
	kwlp; br6

. = 114^.
	trap; br7+10.		/ 11/70 parity

. = 174^.
	tlpio; br5		/ line printer

. = 220^.
	rkio; br5		/ RK05

. = 240^.
	trap; br7+7.		/ programmed interrupt
	trap; br7+8.		/ floating point
	trap; br7+9.		/ segmentation violation

. = 254^.
	dvio; br5		/ DIVA

. = 260^.
	viiin; br4+0.		/ VIILNI
	viiou; br4+0.

. = 300^.
	dlin; br4+1.		/ tty0
	dlou; br4+1.

	dlin; br4+2.		/ tty1
	dlou; br4+2.

	dlin; br4+3.		/ tty2
	dlou; br4+3.

	dlin; br4+4.		/ tty3
	dlou; br4+4.

	dlin; br4+5.		/ tty4
	dlou; br4+5.

	dlin; br4+6.		/ tty5
	dlou; br4+6.

. = 360^.
	dzin; br4+1.		/ dz1 (ttyi-ttyp)
	dzou; br4+1.

	dzin; br4+0.		/ dz0 (ttya-ttyh)
	dzou; br4+0.


//////////////////////////////////////////////////////
/		interface code to C
//////////////////////////////////////////////////////


.globl	call

.globl	_dlrint
dlin:	jsr	r0,call; _dlrint
.globl	_dlxint
dlou:	jsr	r0,call; _dlxint

.globl	_dzrint
dzin:	jsr	r0,call; _dzrint
.globl	_dzxint
dzou:	jsr	r0,call; _dzxint

.globl	_tlpint
tlpio:	jsr	r0,call; _tlpint

.globl	_rkintr
rkio:	jsr	r0,call; _rkintr

.globl	_dvintr
dvio:	jsr	r0,call; _dvintr

.globl	_viiiint, _viioint
viiin:	jsr	r0,call; _viiiint
viiou:	jsr	r0,call; _viioint

.globl	_clock
kwlp:	jsr	r0,call; _clock
