#
/*
 * This table is the switch used to transfer
 * to the appropriate routine for processing a system call.
 * Each row contains the number of arguments expected
 * and a pointer to the routine.
 */
extern nullsys();
extern rexit();
extern fork();
extern read();
extern write();
extern open();
extern close();
extern wait();
extern creat();
extern link();
extern unlink();
extern exec();
extern chdir();
extern gtime();
extern mknod();
extern chmod();
extern chown();
extern sbreak();
extern stat();
extern seek();
extern getpid();
extern smount();
extern sumount();
extern setuid();
extern getuid();
extern stime();
extern ptrace();
extern alarm();
extern fstat();
extern pause();
extern stty();
extern gtty();
extern saccess();
extern nice();
extern sslep();
extern sync();
extern kill();
extern ifetch();
extern getswit();
extern tell();
extern dup();
extern pipe();
extern times();
extern profil();
extern setgid();
extern getgid();
extern ssig();
extern reboot();
extern ttymod();
extern sysacct();
extern fiowt();
extern qtime();
extern netopen();
extern ioctl();
extern getid();
extern nosys();

int	sysent[]
{
	0, &nullsys,			/*  0 = indir */
	0, &rexit,			/*  1 = exit */
	0, &fork,			/*  2 = fork */
	2, &read,			/*  3 = read */
	2, &write,			/*  4 = write */
	2, &open,			/*  5 = open */
	0, &close,			/*  6 = close */
	0, &wait,			/*  7 = wait */
	2, &creat,			/*  8 = creat */
	2, &link,			/*  9 = link */
	1, &unlink,			/* 10 = unlink */
	2, &exec,			/* 11 = exec */
	1, &chdir,			/* 12 = chdir */
	0, &gtime,			/* 13 = time */
	3, &mknod,			/* 14 = mknod */
	2, &chmod,			/* 15 = chmod */
	2, &chown,			/* 16 = chown */
	1, &sbreak,			/* 17 = break */
	2, &stat,			/* 18 = stat */
	2, &seek,			/* 19 = seek */
	0, &getpid,			/* 20 = getpid */
	3, &smount,			/* 21 = mount */
	1, &sumount,			/* 22 = umount */
	0, &setuid,			/* 23 = setuid */
	0, &getuid,			/* 24 = getuid */
	0, &stime,			/* 25 = stime */
	3, &ptrace,			/* 26 = ptrace */
	0, &alarm,			/* 27 = alarm */
	1, &fstat,			/* 28 = fstat */
	0, &pause,			/* 29 = pause */
	1, &nullsys,			/* 30 = smdate; inoperative */
	1, &stty,			/* 31 = stty */
	1, &gtty,			/* 32 = gtty */
	2, &saccess,			/* 33 = access */
	0, &nice,			/* 34 = nice */
	0, &sslep,			/* 35 = sleep */
	0, &sync,			/* 36 = sync */
	1, &kill,			/* 37 = kill */
	0, &getswit,			/* 38 = switch */
	0, &nullsys,			/* 39 = setpgrp (not in yet) */
	0, &tell,			/* 40 = tell */
	0, &dup,			/* 41 = dup */
	0, &pipe,			/* 42 = pipe */
	1, &times,			/* 43 = times */
	4, &profil,			/* 44 = prof */
	0, &ifetch,			/* 45 = ifetch */
	0, &setgid,			/* 46 = setgid */
	0, &getgid,			/* 47 = getgid */
	2, &ssig,			/* 48 = sig */
	1, &ttymod,			/* 49 = ttymod */
	0, &reboot,			/* 50 = reboot */
	1, &sysacct,			/* 51 = turn acct off/on */
	1, &fiowt,			/* 52 = wait for file activity */
	0, &nosys,			/* 53 = x */
	0, &qtime,			/* 54 = time in clicks */
	2, &netopen,			/* 55 = create network device */
	2, &ioctl,			/* 56 = special file control */
	0, &getid,			/* 57 = get unique 16 bit id */
	0, &nosys,			/* 58 = x */
	0, &nosys,			/* 59 = x */
	0, &nosys,			/* 60 = x */
	0, &nosys,			/* 61 = x */
	0, &nosys,			/* 62 = x */
	0, &nosys			/* 63 = x */
};
